## nootka 0.8.60~beta

=== CMakeLists.txt ===
project(nootka)
cmake_minimum_required(VERSION 2.8)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE release)
endif (NOT CMAKE_BUILD_TYPE)
find_package(Qt4 REQUIRED)
INCLUDE( ${QT_USE_FILE} )
add_definitions(${QT_DEFINITIONS})


include_directories(${QT_INCLUDES})

SET(Nootka_VERSION_MAJOR  "0")
SET(Nootka_VERSION_MINOR  "8")
SET(Nootka_VERSION_PATCH  "60-beta")

SET(Nootka_VERSION       "${Nootka_VERSION_MAJOR}.${Nootka_VERSION_MINOR}")
SET(Nootka_VERSION_FULL  "${Nootka_VERSION}.${Nootka_VERSION_PATCH}")

###########################################################################
########   Detecting architecture
###########################################################################
if(WIN32)
  set(PACKAGE_ARCHITECTURE x86)
endif(WIN32)
if(APPLE)
  set(PACKAGE_ARCHITECTURE x86_64)
endif(APPLE)

if(NOT PACKAGE_ARCHITECTURE)
   find_program(DPKG_CMD dpkg)
   if(NOT DPKG_CMD)
      find_program(RPM_CMD rpm)
      if(NOT RPM_CMD)
#         message(STATUS "Can not find any program to determine architecture, default to i386.")
#         set(PACKAGE_ARCHITECTURE i386)
        execute_process(COMMAND uname -m
          OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE
        )
      else(NOT RPM_CMD)
        execute_process(COMMAND "${RPM_CMD}" --eval %_target_cpu
          OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE
        )
      endif(NOT RPM_CMD)
   else(NOT DPKG_CMD)
      execute_process(COMMAND "${DPKG_CMD}" --print-architecture
        OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
        OUTPUT_STRIP_TRAILING_WHITESPACE
      )
      add_definitions(-D_FORTIFY_SOURCE=2) # for lintian DEB_BUILD_HARDENING_FORTIFY
   endif(NOT DPKG_CMD)
endif(NOT PACKAGE_ARCHITECTURE)
message(STATUS "Architecture is ${PACKAGE_ARCHITECTURE}")


###########################################################################
########   Looking for QtMultimedia
###########################################################################
if(QTMULTIMEDIA_LIBRARIES AND QTMULTIMEDIA_INCLUDE_DIRS AND QTMOBILITY_INCLUDE_DIRS)
  set(QTMULTIMEDIA_FOUND TRUE)
else(QTMULTIMEDIA_LIBRARIES AND QTMULTIMEDIA_INCLUDE_DIRS AND QTMOBILITY_INCLUDE_DIRS)
  if(WIN32)
    set(QTMULTIMEDIA_FOUND TRUE)
  else(WIN32) 
    find_path(QTMULTIMEDIA_INCLUDE_DIR
        NAMES
          qaudio.h
        PATHS
          /usr/include
          /usr/local/include
          /opt/local/include
          /sw/include
          /usr/include/QtMultimedia
          /usr/include/QtMultimediaKit
          /usr/include/QtMobility
    )
    find_path(QTMOBILITY_INCLUDE_DIR
        NAMES
          qmobilityglobal.h
        PATHS
          /usr/include
          /usr/local/include
          /opt/local/include
          /sw/include
          /usr/include/QtMultimedia
          /usr/include/QtMultimediaKit
          /usr/include/QtMobility
    )
	if(NOT QTMOBILITY_INCLUDE_DIR) # Dostros other than Ubuntu/Mint haven't qmobilityglobal dependices
	  set(QTMOBILITY_INCLUDE_DIR /usr/include) # and this var is unused
	endif(NOT QTMOBILITY_INCLUDE_DIR)

  endif(WIN32)

    find_library(QTMULTIMEDIA_LIBRARY
                  NAMES
                        QtMultimediaKit
                  PATHS
                        /usr/lib
                        /usr/lib64
                        /usr/local/lib
                        /opt/local/lib
    )

  if (NOT QTMULTIMEDIA_LIBRARY)
    find_library(QTMULTIMEDIA_LIBRARY
                  NAMES
                        QtMultimedia
                  PATHS
                        /usr/lib
                        /usr/lib64
                        /usr/local/lib
                        /opt/local/lib
    )
  endif(NOT QTMULTIMEDIA_LIBRARY)

  set(QTMULTIMEDIA_INCLUDE_DIRS 
      ${QTMULTIMEDIA_INCLUDE_DIR} 
    )
  set(QTMULTIMEDIA_LIBRARIES
      ${QTMULTIMEDIA_LIBRARY} 
    )
  set(QTMOBILITY_INCLUDE_DIRS
      ${QTMOBILITY_INCLUDE_DIR}
  )

  if(QTMULTIMEDIA_INCLUDE_DIRS AND QTMULTIMEDIA_LIBRARIES AND QTMOBILITY_INCLUDE_DIRS)
    set(QTMULTIMEDIA_FOUND TRUE)
  endif(QTMULTIMEDIA_INCLUDE_DIRS AND QTMULTIMEDIA_LIBRARIES AND QTMOBILITY_INCLUDE_DIRS)

  if(QTMULTIMEDIA_FOUND)
      message(STATUS "QtMultimedia was Found in:\n${QTMULTIMEDIA_LIBRARIES}\n${QTMULTIMEDIA_INCLUDE_DIRS}\n${QTMOBILITY_INCLUDE_DIRS} ")
  else(QTMULTIMEDIA_FOUND)
      message(FATAL_ERROR 
        "Could not find QtMultimedia\nTry call cmake with args:\n-DQTMULTIMEDIA_LIBRARIES=/path_to/libQtMultimedia(Kit).la(dll) -DQTMULTIMEDIA_INCLUDE_DIRS=/path_to_dir_with/qaudio.h -DQTMOBILITY_INCLUDE_DIRS=/path_to_dir_with/qmobilityglobal.h")
  endif(QTMULTIMEDIA_FOUND)

endif(QTMULTIMEDIA_LIBRARIES AND QTMULTIMEDIA_INCLUDE_DIRS AND QTMOBILITY_INCLUDE_DIRS)

include_directories(${QTMULTIMEDIA_INCLUDE_DIRS})
include_directories(${QTMOBILITY_INCLUDE_DIRS}) 

###########################################################################
########   Looking for fftw3
###########################################################################
IF(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)
  set(FFTW3_FOUND TRUE)
ELSE(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)
  find_path(FFTW3_INCLUDE_DIR
    NAMES
      fftw3.h
    PATHS
      /usr/include
      /usr/local/include
      /opt/local/include
      /sw/include
      "${CMAKE_CURRENT_SOURCE_DIR}/fftw"
      "${CMAKE_CURRENT_BINARY_DIR}/fftw"
  )
  IF(WIN32)
    find_library(FFTW3_LIBRARY
      NAMES
        fftw3f.dll
      PATHS
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
    )
  ELSE(WIN32)
    find_library(FFTW3_LIBRARY
      NAMES
        fftw3f
      PATHS
        /usr/lib
        /usr/lib64
        /usr/local/lib
        /opt/local/lib
        /sw/lib
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
  )
  ENDIF(WIN32)

  set(FFTW3_INCLUDE_DIRS
    ${FFTW3_INCLUDE_DIR}
  )
  set(FFTW3_LIBRARIES
    ${FFTW3_LIBRARY}
)

  IF(FFTW3_INCLUDE_DIRS AND FFTW3_LIBRARIES)
     set(FFTW3_FOUND TRUE)
  ENDIF(FFTW3_INCLUDE_DIRS AND FFTW3_LIBRARIES)

  IF(FFTW3_FOUND)
      message(STATUS "Fftw3 was Found in:\n${FFTW3_LIBRARIES}\n${FFTW3_INCLUDE_DIRS}")
  ELSE(FFTW3_FOUND)
      message(FATAL_ERROR "Could not find Fftw3\nTry call cmake with args:\n-DFFTW3_LIBRARIES=/path_to/libfftw3.la(dll) -DFFTW3_INCLUDE_DIRS=/path_to_dir_with/fftw3.h\nor put those files in build dir or source dir")
  ENDIF(FFTW3_FOUND)

ENDIF(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)

include_directories(${FFTW3_INCLUDE_DIRS})

message("Qt is in: ${QT_BINARY_DIR}")

###########################################################################
#libraries and compiller definitions for RtMidi
###########################################################################
if (APPLE)
      find_library(CoreAudio_LIB             NAMES CoreAudio)
      find_library(CoreMidi_LIB              NAMES CoreMIDI)
      find_library(CoreFoundation_LIB        NAMES CoreFoundation)
endif (APPLE)

IF(UNIX AND NOT APPLE)
  find_library(ALSA_LIBRARY
		  NAMES
			asound
		  PATHS
			/usr/lib
			/usr/lib/x86_64-linux-gnu
			/usr/local/lib
			/opt/local/lib
  )
  find_library(PTHREAD_LIBRARY
		  NAMES
			pthread
		  PATHS
			/usr/lib
			/usr/lib/x86_64-linux-gnu
			/usr/local/lib
			/opt/local/lib
  )
  mark_as_advanced(ALSA_LIBRARY PTHREAD_LIBRARY)

  add_definitions(-D__LINUX_ALSASEQ__)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
  add_definitions(-D__WINDOWS_MM__)
ENDIF(WIN32)

if(APPLE)
  add_definitions(-D__MACOSX_CORE__)
endif(APPLE)

if (CMAKE_BUILD_TYPE MATCHES 'release')
# set (CMAKE_CXX_FLAGS_RELEASE "-DQT_NO_DEBUG")
  add_definitions(-DQT_NO_DEBUG)
endif (CMAKE_BUILD_TYPE MATCHES 'release')


add_subdirectory(src)


###########################################################################
#INSTALLATION
###########################################################################
if(WIN32)
    set(INS_PREF ".")
else(WIN32)
  if (APPLE)
    set(INS_PREF "nootka.app/Contents/Resources")
  else(APPLE)
    set(INS_PREF "share/nootka")
  endif(APPLE)
endif(WIN32)


if(APPLE)
  INSTALL( CODE"
      execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/packaging/mac/install.sh ${CMAKE_BINARY_DIR} ${QT_BINARY_DIR} ${FFTW3_LIBRARIES} )
  " )
	INSTALL(FILES "${CMAKE_SOURCE_DIR}/picts/nootka.icns" DESTINATION "${INS_PREF}") # icns for mac
	INSTALL(FILES "${CMAKE_SOURCE_DIR}/picts/nootka-levels.icns" DESTINATION "${INS_PREF}")
	INSTALL(FILES "${CMAKE_SOURCE_DIR}/picts/nootka-exam.icns" DESTINATION "${INS_PREF}")
endif(APPLE)

INSTALL(FILES gpl DESTINATION "${INS_PREF}")
INSTALL(FILES changes DESTINATION "${INS_PREF}")
FILE(GLOB ICONS_PNG "${CMAKE_CURRENT_SOURCE_DIR}/picts/*.png") #png-s for all
INSTALL(FILES ${ICONS_PNG} DESTINATION "${INS_PREF}/picts")
INSTALL(DIRECTORY fonts DESTINATION "${INS_PREF}")
FILE(GLOB langs "${CMAKE_CURRENT_SOURCE_DIR}/lang/*.qm")
if(APPLE OR WIN32)
  LIST(APPEND langs "${QT_TRANSLATIONS_DIR}/qt_cs.qm" "${QT_TRANSLATIONS_DIR}/qt_fr.qm" "${QT_TRANSLATIONS_DIR}/qt_pl.qm" )
endif(APPLE OR WIN32)
INSTALL(FILES ${langs} DESTINATION "${INS_PREF}/lang")
FILE(GLOB snds "${CMAKE_CURRENT_SOURCE_DIR}/sounds/classical-guitar.wav")
INSTALL(FILES ${snds} DESTINATION "${INS_PREF}/sounds")

if(NOT UNIX) # Windows icons
  INSTALL(FILES picts/nootka-exam.ico picts/nootka.ico picts/nootka-icon.rc picts/nootka-levels.ico picts/pack.ico picts/nootka.rc DESTINATION "${INS_PREF}/picts") #ico for windows
  INSTALL(FILES packaging/nsis/nootka-1250.nsi packaging/nsis/fileasoc.nsh DESTINATION "${INS_PREF}" )
endif(NOT UNIX)

# files related with Linux (mime, desktop entry, icons)
if(UNIX AND NOT APPLE)
    INSTALL(FILES mime/nootka.desktop DESTINATION share/applications)
    INSTALL(FILES picts/nootka.svg DESTINATION "${INS_PREF}/picts")
    INSTALL(FILES picts/nootka.svg picts/levelCreator.png picts/nootka-exam.png DESTINATION share/pixmaps)
    INSTALL( CODE"
      execute_process(COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/mime )
      execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/mime/install-mime.sh ${CMAKE_INSTALL_PREFIX} ${CMAKE_CURRENT_BINARY_DIR}/mime ${CMAKE_CURRENT_SOURCE_DIR}/mime)" )
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/mime/nootka.xml DESTINATION share/mime/packages)
	INSTALL( CODE"
      execute_process(COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/doc )
      execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/packaging/make-chlog.sh ${Nootka_VERSION_FULL} ${CMAKE_CURRENT_BINARY_DIR}/doc/changelog ${CMAKE_CURRENT_SOURCE_DIR})
	" )
	if (DPKG_CMD) # Debian changelog
      INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/doc/changelog.Debian.gz" DESTINATION share/doc/nootka)
  endif (DPKG_CMD)
	INSTALL(FILES copyright DESTINATION share/doc/nootka)
	INSTALL(FILES packaging/nootka.1.gz DESTINATION share/man/man1)
    
endif(UNIX AND NOT APPLE)

###########################################################################
# uninstall target
###########################################################################
configure_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

  add_custom_target(uninstall
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)


# add_subdirectory(mime) # target for make install-mime
add_subdirectory(packaging) # cpack rules

=== packaging/CMakeLists.txt ===
##########################################################################################
#			COMMON SETTINGS  ##########################################################
##########################################################################################

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Application to help with learning classical score notation.")
set(CPACK_PACKAGE_VENDOR "Nootka")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/packaging/nootka-desc")
set(CPACK_RESOURCE_FILE_LICENSE    "${PROJECT_SOURCE_DIR}/gpl")

set(CPACK_PACKAGE_VERSION_MAJOR ${Nootka_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${Nootka_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${Nootka_VERSION_PATCH})
set(CPACK_PACKAGE_VERSION ${Nootka_VERSION_FULL})

set(CPACK_PACKAGE_CONTACT "See Look <seelook@gmail.com>")

set(CPACK_PACKAGE_NAME "nootka")
set(CPACK_PACKAGE_FILE_NAME "nootka_${CPACK_PACKAGE_VERSION}_${PACKAGE_ARCHITECTURE}")


##########################################################################################
#		cmake/cpack	DEB  generator 
##########################################################################################
set(CPACK_DEBIAN_PACKAGE_NAME "nootka") #default CPACK_PACKAGE_NAME
# message(STATUS ${CPACK_DEBIAN_PACKAGE_NAME} )
# CPACK_DEBIAN_PACKAGE_VERSION #CPACK_PACKAGE_VERSION
# PACKAGE_ARCHITECTURE #dpkg --print-architecture or i386
# set(CPACK_DEBIAN_PACKAGE_NAME "nootka" )
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.9), libqtcore4 | libqt4-core, libqtgui4 | libqt4-gui, libqtmultimediakit1, libfftw3-3")
#CPACK_DEBIAN_PACKAGE_MAINTAINER #CPACK_PACKAGE_CONTACT
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "Application to help with learning classical score notation.
 Mostly it is for guitarists,
 but it can be used for ear training as well.
 .
 Features:
 numerous settings to personalise for user needs and capabilities
 accurate method for detecting sung and played sounds
 different name-callings of the notes
 support for scordatures
 exam mode with different levels to registry progresses
 levels creator with wide range of settings
 .
 http://nootka.sf.net") #CPACK_PACKAGE_DESCRIPTION_SUMMARY
set(CPACK_DEBIAN_PACKAGE_SECTION "science")
# CPACK_DEBIAN_PACKAGE_PRIORITY #optional
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://nootka.sf.net")
set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "timidity")
set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/debian/postinst;${CMAKE_CURRENT_SOURCE_DIR}/debian/postrm" )


##########################################################################################
#		cmake/cpack	RPM  generator 
##########################################################################################
# CPACK_RPM_PACKAGE_SUMMARY #CPACK_PACKAGE_DESCRIPTION_SUMMARY
set(CPACK_RPM_PACKAGE_NAME "nootka")# Default   : CPACK_PACKAGE_NAME
# CPACK_RPM_PACKAGE_VERSION # Default   : CPACK_PACKAGE_VERSION
# CPACK_RPM_PACKAGE_ARCHITECTURE # Default   : -
set(CPACK_RPM_PACKAGE_RELEASE "3")
set(CPACK_RPM_PACKAGE_LICENSE "GPLv3")
set(CPACK_RPM_PACKAGE_GROUP "Applications/Education")
set(CPACK_RPM_PACKAGE_VENDOR "Nootka")
set(CPACK_RPM_PACKAGE_URL "http://nootka.sf.net")
# CPACK_RPM_PACKAGE_DESCRIPTION # Default   : CPACK_PACKAGE_DESCRIPTION_FILE if set or "no package description available"
# CPACK_RPM_COMPRESSION_TYPE #  Possible value are: lzma, xz, bzip2 and gzip.
# set(CPACK_RPM_PACKAGE_REQUIRES "libQtGui >= 4.6, qt-devel, fftw-3")
#Mandriva libfftw3
#Suse fftw3 libqt4-devel
#Fedora fftw qt-devel
#CentOs fftw
set(CPACK_RPM_PACKAGE_SUGGESTS "timidity")
# set(CPACK_RPM_SPEC_INSTALL_POST "/usr/bin/update-desktop-database &> /dev/null || :
# /usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :")
# CPACK_RPM_SPEC_MORE_DEFINE # May be used to add any %define lines to the generated spec file.
# CPACK_RPM_PACKAGE_DEBUG # cpack -D CPACK_RPM_PACKAGE_DEBUG=1 -G RPM
set(CPACK_RPM_USER_BINARY_SPECFILE "${CMAKE_CURRENT_SOURCE_DIR}/rpm/nootka.spec.in")
#             Mandatory : NO
#             Default   : -
#             May be set by the user in order to specify a USER binary spec file
#             to be used by CPackRPM instead of generating the file.
#             The specified file will be processed by CONFIGURE_FILE( @ONLY).
#          CPACK_RPM_GENERATE_USER_BINARY_SPECFILE_TEMPLATE
#             Mandatory : NO
#             Default   : -
#             If set CPack will generate a template for USER specified binary
#             spec file and stop with an error. For example launch CPack like this
#             cpack -D CPACK_RPM_GENERATE_USER_BINARY_SPECFILE_TEMPLATE=1 -G RPM
#             The user may then use this file in order to hand-craft is own
#             binary spec file which may be used with CPACK_RPM_USER_BINARY_SPECFILE.
#          CPACK_RPM_PRE_INSTALL_SCRIPT_FILE
#          CPACK_RPM_PRE_UNINSTALL_SCRIPT_FILE
#             Mandatory : NO
#             Default   : -
#             May be used to embbed a pre (un)installation script in the spec file.
#             The refered script file(s) will be read and directly
#             put after the %pre or %preun section
#             One may verify which scriptlet has been included with
#              rpm -qp --scripts  package.rpm
set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/rpm/rpm-post.sh")
set(CPACK_RPM_POST_UNINSTALL_SCRIPT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/rpm/rpm-post.sh")
#             Mandatory : NO
#             Default   : -
#             May be used to embbed a post (un)installation script in the spec file.
#             The refered script file(s) will be read and directly
#             put after the %post or %postun section
#             One may verify which scriptlet has been included with
#              rpm -qp --scripts  package.rpm
set(CPACK_RPM_CHANGELOG_FILE "${CMAKE_BINARY_DIR}/doc/changelog-rpm")



##########################################################################################
#			Resume              ##########################################################
##########################################################################################

if (WIN32)
  set(CPACK_GENERATOR  "NSIS")
#   set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/packaging" ${CMAKE_MODULE_PATH}) # Use custom version of NSIS.InstallOptions.ini
else (WIN32)
  if (NOT APPLE)
    set(CPACK_STRIP_FILES "nootka")
    set(CPACK_GENERATOR "RPM;DEB")
    set(CPACK_DEB "on")
  else (NOT APPLE)
    set(CPACK_GENERATOR "OSXX11")
#     set(CPACK)
  endif (NOT APPLE)
endif (WIN32)

include (CPack)

###########################################################################
#	packaging targets (make src)
###########################################################################
if(UNIX AND NOT APPLE)
    execute_process(COMMAND printf "\n\n\nTo build src package call:\n")
    execute_process(COMMAND printf "\tmake src\n\n\n" )

	add_custom_target(src
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/src/make-src.sh ${Nootka_VERSION_FULL} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}
   )
ENDIF(UNIX AND NOT APPLE)

###########################################################################
# packaging targets (make mac)
###########################################################################
# if(${UNIX})
#     execute_process(COMMAND printf "\n\n\nTo prepare independency of mac boundle:\n")
#     execute_process(COMMAND printf "\tmake mac\n\n\n" )
# 
#   add_custom_target(mac
#   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/mac/linking.sh ${QT_LIBRARY_DIR} ${QTMULTIMEDIA_LIBRARIES} ${FFTW3_LIBRARIES} ${CMAKE_BINARY_DIR}
#    )
# ENDIF(${UNIX})
#${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY}



#### OBSOLETE ##########################
###########################################################################
#	packaging targets (make deb)
###########################################################################
# IF(UNIX AND NOT APPLE)
#     execute_process(COMMAND printf "\n\n\nTo build deb package call:\n")
#     execute_process(COMMAND printf "\tmake deb\n\n\n" )
# 
# 	add_custom_target(deb
# 	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/build-deb.sh ${Nootka_VERSION_FULL} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "${CMAKE_BINARY_DIR}/debian"
#    )
# 	
# 	add_custom_target(rpm
# 	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/build-rpm.sh ${Nootka_VERSION_FULL} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "${CMAKE_BINARY_DIR}/rpm"
#    )

=== src/CMakeLists.txt ===
################################################

INCLUDE_DIRECTORIES (. exam info level score settings sound charts)

SET( NOOTKA_SRCS
  main.cpp
  mainwindow.cpp
  tglobals.cpp
  tnote.cpp
  tnotename.cpp
  tfingerboard.cpp
  ttune.cpp
  tfingerpos.cpp
###### Score
  score/tnoteview.cpp
  score/tscorewidget.cpp
  score/tscorewidgetsimple.cpp
  score/tkeysignatureview.cpp
  score/tkeysignature.cpp
  score/tclefview.cpp
  score/tpushbutton.cpp
  score/tscordatureview.cpp
###### Settings
  settings/settingsdialog.cpp
  settings/tsettingsdialogbase.cpp
  settings/namesettings.cpp
  settings/tnotationradiogroup.cpp
  settings/scoresettings.cpp
  settings/examsettings.cpp
  settings/tcolorbutton.cpp
###### Level
  level/tlevelcreatordlg.cpp
  level/texamlevel.cpp
  level/levelsettings.cpp
  level/questionssettings.cpp
  level/accidsettings.cpp
  level/tlevelselector.cpp
  level/rangesettings.cpp
  level/tquestionaswdg.cpp
  level/tkeysigncombobox.cpp
  level/tlevelheaderwdg.cpp
  level/tlevelpreview.cpp
###### Exam
  exam/tqatype.cpp
  exam/texamexecutor.cpp
  exam/tstartexamdlg.cpp
  exam/tqaunit.cpp
  exam/texamview.cpp
  exam/texam.cpp
  exam/texamsummary.cpp
  exam/texamparams.h
  exam/texecutorsupply.cpp
  exam/tquestiontip.cpp
  exam/tcanvas.cpp
  exam/tanimedtextitem.cpp
  exam/tprogresswidget.cpp
  exam/tgroupedqaunit.cpp
###### Info
  info/taboutnootka.cpp
  info/tfirstrunwizzard.cpp
  info/select7note.cpp
  info/texamhelp.cpp
  info/texpertanswerhelp.cpp
  info/tsupportnootka.cpp
  info/tnootkalabel.cpp
  info/tpixmaker.cpp
###### Charts
  charts/tanalysdialog.cpp
  charts/tchart.cpp
  charts/tabstractaxis.cpp
  charts/txaxis.cpp
  charts/tyaxis.cpp
  charts/tmainline.cpp
  charts/tquestionpoint.cpp
  charts/tmainchart.cpp
  charts/tlinearchart.cpp
  charts/tbarchart.cpp
  charts/tbar.cpp
  charts/tstafflinechart.cpp
  charts/ttipchart.cpp
  charts/tnotepixmap.cpp
  charts/tgraphicstexttip.cpp
  charts/tgraphicsline.cpp
  charts/sorting.cpp
  charts/tdropshadoweffect.cpp
  charts/tstatisticstip.cpp
  charts/ttiphandler.cpp
###### Sound
  sound/tsound.cpp
  sound/taudioout.cpp
  sound/taudioin.cpp
  sound/audiooutsettings.cpp
  sound/audioinsettings.cpp
  sound/RtMidi.cpp
  sound/taudioparams.h
  sound/tpitchfinder.cpp
  sound/tvolumemeter.cpp
  sound/tpitchview.cpp
  sound/tartiniparams.h
# tartini
  sound/tartini/channel.cpp
  sound/tartini/analysisdata.cpp
  sound/tartini/mytransforms.cpp
  sound/tartini/notedata.cpp
  sound/tartini/bspline.cpp
  sound/tartini/conversions.cpp
  sound/tartini/useful.cpp
  sound/tartini/fast_smooth.cpp
  sound/tartini/array1d.h
  sound/tartini/large_vector.h
  sound/tartini/SmartPtr.h
 # filters
  sound/tartini/filters/Filter.h
  sound/tartini/filters/FastSmoothedAveragingFilter.cpp
  sound/tartini/filters/FixedAveragingFilter.cpp
  sound/tartini/filters/GrowingAveragingFilter.cpp
  sound/tartini/filters/IIR_Filter.cpp
  )

#SET( NOOTKA_HEADERS
#    tfingerpos.h
#)
  
SET( NOOTKA_MOC_SRCS
  mainwindow.h
  tnotename.h
  tfingerboard.h
###### Score
  score/tnoteview.h
  score/tscorewidget.h
  score/tscorewidgetsimple.h
  score/tkeysignatureview.h
  score/tclefview.h
  score/tpushbutton.h
###### Settings
  settings/settingsdialog.h
  settings/tsettingsdialogbase.h
  settings/namesettings.h
  settings/tnotationradiogroup.h
  settings/scoresettings.h
  settings/examsettings.h
  settings/tcolorbutton.h
###### Level
  level/tlevelcreatordlg.h
  level/levelsettings.h
  level/questionssettings.h
  level/accidsettings.h
  level/tlevelselector.h
  level/rangesettings.h
  level/tquestionaswdg.h
  level/tkeysigncombobox.h
  level/tlevelheaderwdg.h
  level/tlevelpreview.h
###### Exam
  exam/tstartexamdlg.h
  exam/texamview.h
  exam/texamexecutor.h
  exam/texamsummary.h
  exam/texecutorsupply.h
  exam/tcanvas.h
  exam/tprogresswidget.h
  exam/tquestiontip.h
  exam/tanimedtextitem.h
###### Info
  info/taboutnootka.h
  info/tfirstrunwizzard.h
  info/select7note.h
  info/texamhelp.h
  info/texpertanswerhelp.h
  info/tsupportnootka.h
###### Charts
  charts/tanalysdialog.h
  charts/tchart.h
  charts/tmainchart.h
  charts/ttiphandler.h
###### Sound
  sound/tsound.h
  sound/taudioout.h
  sound/taudioin.h
  sound/audiooutsettings.h
  sound/audioinsettings.h
  sound/tpitchfinder.h
  sound/tvolumemeter.h
  sound/tpitchview.h
  )


QT4_WRAP_CPP( NOOTKA_MOCS ${NOOTKA_MOC_SRCS} )

if(RPM_CMD)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
endif(RPM_CMD)


if(MINGW)
 # dress up win executable in nice nootka icon ONLY FOR MINGW !!!!!!!!!!!!!
    ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/nootico.o
                       COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR} -i${CMAKE_CURRENT_SOURCE_DIR}/../picts/nootka-icon.rc
                            -o ${CMAKE_CURRENT_BINARY_DIR}/nootico.o )
    SET(NOOTKA_SRCS ${NOOTKA_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/nootico.o)
    ADD_EXECUTABLE( nootka WIN32 ${NOOTKA_SRCS} ${NOOTKA_MOCS} nootico.o )
	TARGET_LINK_LIBRARIES(nootka
        ${QT_QTCORE_LIBRARY}
        ${QT_QTGUI_LIBRARY}
        ${QTMULTIMEDIA_LIBRARIES}
        ${FFTW3_LIBRARIES}
        winmm
	)
endif(MINGW)

if(UNIX AND NOT APPLE) #Linux
    ADD_EXECUTABLE( nootka
        ${NOOTKA_SRCS}
        ${NOOTKA_MOCS}
    #        ${NOOTKA_RCC_SRCS}
    )
	TARGET_LINK_LIBRARIES(nootka
        ${QT_QTCORE_LIBRARY}
        ${QT_QTGUI_LIBRARY}
        ${QTMULTIMEDIA_LIBRARIES}
        ${FFTW3_LIBRARIES}
        ${ALSA_LIBRARY} ${PTHREAD_LIBRARY}
	)
endif(UNIX AND NOT APPLE)

if(APPLE)
    set (MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/packaging/mac/info.plist")
   set (ExeName nootka MACOSX_BUNDLE)
   set (MACOSX_BUNDLE_INFO_STRING Nootka release for Mac OSX)
   set (MACOSX_BUNDLE_ICON_FILE      "nootka.icns")
   set (MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.nootka)
   set (MACOSX_BUNDLE_LONG_VERSION_STRING ${Nootka_VERSION_FULL})
   set (MACOSX_BUNDLE_BUNDLE_NAME Nootka)
   set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${Nootka_VERSION_FULL})
   set (MACOSX_BUNDLE_BUNDLE_VERSION ${Nootka_VERSION_FULL})
   set (MACOSX_BUNDLE_COPYRIGHT nootka.sf.net)
    ADD_EXECUTABLE( ${ExeName}
        ${NOOTKA_SRCS}
        ${NOOTKA_MOCS}
    )
  TARGET_LINK_LIBRARIES(nootka
        ${QT_QTCORE_LIBRARY}
        ${QT_QTGUI_LIBRARY}
        ${QTMULTIMEDIA_LIBRARIES}
        ${FFTW3_LIBRARIES}
        ${CoreAudio_LIB}
        ${CoreMidi_LIB}
        ${CoreFoundation_LIB}        
  )
endif(APPLE)




if(UNIX AND NOT APPLE) 	# Linux path for Nootka binary
  install(TARGETS nootka DESTINATION bin)
else(UNIX AND NOT APPLE)
  if(WIN32) 			# Windows
    install(TARGETS nootka DESTINATION .)
  else(WIN32) 			# MacOs
    install(TARGETS nootka BUNDLE DESTINATION ${CMAKE_INSTALL_PREFIX})
    install( CODE"
    execute_process(COMMAND echo copying info.plist )
    execute_process(COMMAND sh ${CMAKE_SOURCE_DIR}/packaging/mac/grabInfo.sh ${Nootka_VERSION_FULL} ${CMAKE_SOURCE_DIR} ${CMAKE_INSTALL_PREFIX} )"
    )
  endif(WIN32)
endif(UNIX AND NOT APPLE)

=== debian/changelog ===
nootka (0.8.60~beta-0ubuntu5) raring; urgency=low

  * Remove qtmultimedia5-dev since it is non-used and powerpc can't build

 -- Howard Chan <smartboyhw@gmail.com>  Fri, 05 Apr 2013 19:00:47 +0800

nootka (0.8.60~beta-0ubuntu4) raring; urgency=low

  [ Prasad Murthy ]
  * Fix qmaxqminarm.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 03 Apr 2013 17:20:59 +0100

nootka (0.8.60~beta-0ubuntu3) raring; urgency=low

  [ Prasad Murthy ]
  * Fix qmaxqminarm.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 03 Apr 2013 16:42:37 +0100

nootka (0.8.60~beta-0ubuntu2) raring; urgency=low

  [ Prasad Murthy ]
  * Add qmaxqminarm.patch to fix compile on ARM

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 01 Apr 2013 14:21:01 +0100

nootka (0.8.60~beta-0ubuntu1) raring; urgency=low

  * Initial packaging of version 0.8.60 beta. (LP: #1157859)

 -- Howard Chan <smartboyhw@gmail.com>  Fri, 22 Mar 2013 22:04:15 +0800

=== debian/control ===
Source: nootka
Section: sound
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Howard Chan <smartboyhw@gmail.com>
Build-Depends: debhelper (>= 8.0.0), cmake, pkg-kde-tools, libqt4-dev, qtmobility-dev, libfftw3-dev, libasound2-dev
Standards-Version: 3.9.4
Homepage: http://nootka.sourceforge.net/
#Vcs-Git: git://git.debian.org/collab-maint/nootka.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/nootka.git;a=summary

Package: nootka
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This package nootka provides an application to learn classical score notation.
 Nootka is an application to learn classical score notation.
 It helps to understand the rules of reading and writing scores
 and develops skills for playing and singing notes.
